#ifndef _CONTENTSDIRECTORY_
#define _CONTENTSDIRECTORY_
#include "win.h"
#include "basetools.h"

class THIContentsDirectory:public THIWin
{
   private: 
         TWinControl *_Parent; void Start(); void Scroll();
            static void _OnMouseUp(void *ClassPointer,void *Param)
            { _hie(THIContentsDirectory)->Start(); }
            static void _OnClick(void *ClassPointer,void *Param)
            { _hie(THIContentsDirectory)->Scroll(); }
            static void _OnDblClick(void *ClassPointer,void *Param)
            { _hi_onEvent( _hie(THIContentsDirectory)->_event_onDblClick); }
     
    protected:
    TList *FList;
     
   public:
    int cd; //  
    int cf;
    int d;
    int sel;
    string store;
    string slc; // 
    string name;
     bool _prop_VScrollBar;
    HICON _prop_IconBack;
    HICON _prop_IconDir;
    HICON _prop_IconExe;
    HICON _prop_IconAny;
    HICON _prop_IconTxt;
    HICON _prop_IconDll;
    HICON _prop_IconIni;
    HICON _prop_IconLnk;
    string _prop_Dir;
    THI_Event *_data_Dir;
    THI_Event *_event_onKeyDown;
    THI_Event *_event_onPosition;
    THI_Event *_event_onChange;

    THIContentsDirectory(TWinControl *Parent)
    { _Parent = Parent; }

    void Init();
    HI_WORK_LOC(THIContentsDirectory,_work_doOpen);
    HI_WORK_LOC(THIContentsDirectory,_work_doRefresh){TData qt;_work_doAdd(qt,0);sel=0;_work_doAdd(qt,0);}
    HI_WORK_LOC(THIContentsDirectory,_work_doVScroll);
    HI_WORK(_work_doSelect){ ((TContentsDirectory *)_hie(THIContentsDirectory)->Control)->SelIndex = ToInteger(_Data); }
    HI_WORK_LOC(THIContentsDirectory,_work_doAdd);
    HI_WORK(_var_Index){ CreateData(_Data,((TContentsDirectory *)_hie(THIContentsDirectory)->Control)->SelIndex); }
    HI_WORK(_var_Text){ CreateData(_Data,_hie(THIContentsDirectory)->FList->Text); }
    HI_WORK(_var_Count){ CreateData(_Data,_hie(THIContentsDirectory)->FList->Count()); }
    HI_WORK_LOC(THIContentsDirectory,_var_String){CreateData(_Data,(*FList)[ (int)((TContentsDirectory *)Control)->SelIndex ]); }
    HI_WORK_LOC(THIContentsDirectory,_var_LongStr)
    {      
           int len=0;
           int i=0;
           int cnt=FList->Count();
           while(i<cnt)
           {
              int t=SendMessage(Control->Handle,LB_GETTEXTLEN,i,0);
               if(t>len)
                 len=t;
              i++; 
           }
          CreateData(_Data,len); 
           if(len>14)// -    
             {   
          ((TContentsDirectory*)Control)->Style = WS_HSCROLL;          
         SendMessage(Control->Handle,LB_SETHORIZONTALEXTENT,len*11,0); 
             }  
    }
      
};

//////////////////////////////////////////////////////////////////////////
  
void THIContentsDirectory::Init()
{
    long fl = 0;
       if(_prop_VScrollBar)
         fl |= WS_VSCROLL|WS_HSCROLL;
       else  fl |= WS_HSCROLL;     
    Control = new TContentsDirectory(_Parent,fl);
    FList = ((TContentsDirectory*)Control)->Lines;  
         THIWin::Init(); 
              TData qt;
           _work_doAdd(qt,0); 
   Control->OnMouseUp = DoNotifyEvent(this,_OnMouseUp);         
   Control->OnClick = DoNotifyEvent(this,_OnClick);
   Control->OnDblClick = DoNotifyEvent(this,_OnDblClick);
} 

 void THIContentsDirectory::_work_doAdd(TData &_Data,WORD Index)
{             
               string back=L"     .....";
               string bgn=L"*.*";
               string e =L"\\" ;
               string sp = L"     "; //5
               string dir = ReadString(_Data,_data_Dir,_prop_Dir);
               string hide = sp+dir;
               if(sel==0) //  back
               {    
                   int cn=1;
                  int i=1;
                  while(cn>0)
                 {  cn=name.PosEx(e,i);
                  i++; }
                  name.Delete(i-2,4); 
                 int len= name.Length();
                 i=1;
                 cn=1;
                 while(cn>0)
                  {  cn=name.PosEx(e,i);
                  i++;}
                  int ps=len-(i-2);
                  name.Delete(i-2,int(ps)+1); 
                  string up=name; 
                  name=name+e+bgn;
                  store=up;
                   slc=L"";
                   FList->Clear();
               }
             else { if(slc==SNULL) // 
                     name=bgn; 
                  else name=store+slc+e+bgn;} // 
                  
                  if(sel<=cd)//  
               {          
                   cd=0;  
               bool nxt=false; 
                WIN32_FIND_DATA FileData; 
                 HANDLE hSearch;
              FList->Add(back);
              hSearch = FindFirstFile (PChar(name),&FileData);
                  if (!(hSearch == INVALID_HANDLE_VALUE))
                 nxt=true;           
              while(nxt)
                 {         
                 string f = FileData.cFileName;            
                string spf = sp+f; 
                   if(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
                       {            
                     FList->Add(spf);
                     cd++;
                       }
            nxt = FindNextFile(hSearch,&FileData);
                  } 
                if(!dir.Empty()&&store==SNULL){FList->Add(hide);cd++;}//  
                   hSearch = FindFirstFile (PChar(name),&FileData);
                  if (!(hSearch == INVALID_HANDLE_VALUE))
                  nxt=true; 
               while(nxt)
                 {         
                 string f = FileData.cFileName;            
                string spf = sp+f; 
                   if (!(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
                       {            
                     FList->Add(spf);
                       }
            nxt = FindNextFile(hSearch,&FileData);
                  }  
         FindClose (hSearch);
        
         store=store+slc+e;      
              d=1;
            TData qt; 
           _var_LongStr(qt,0);
           _work_doOpen(qt,0);  
     }
         int lng= name.Length();
         string out=name;   
  _hi_onEvent(_event_onChange,out.Delete(lng-3,4));
  
}

 void THIContentsDirectory::_work_doOpen(TData &_Data,WORD Index)
{           
     int top = SendMessage(Control->Handle,LB_GETTOPINDEX,0,0)*22;
             int id=0;  //  
            int indx=22-top;//       
            cf=cd+1; //   
           int cnt= FList->Count();//    ListBox
            HI_RSTRING buf[128]; 
            HICON hIconSmall;      
      HWND bn=Control->Handle ;
                 UpdateWindow( bn);
             PAINTSTRUCT ps;
         HDC dc = BeginPaint(bn, &ps);
         DrawIconEx(Control->dc,5,top,_prop_IconBack,24,24,0,NULL,DI_NORMAL);  
         while(id<cd)   //  
         {
    bool icon= DrawIconEx(Control->dc,5,indx,_prop_IconDir,24,24,0,NULL,DI_NORMAL); 
                     if (icon == NULL)
        MessageBox(NULL,L" !",L"Error",MB_OK);
                 id++; 
                 indx+=22;//  .          
            }      
             
         while(cf<cnt)  //  
         {                                        
         SendMessage(Control->Handle,LB_GETTEXT,cf,(long)buf); //                                                              
              string rs=buf;
              rs.Lower();
              rs.Delete(1,5);
              string n=name;
              int lng= n.Length();
              n.Delete(lng-2,3);
              string rr=n+rs;
                  string ext =L".exe";
             wchar_t*fn= wcsstr(PChar(rs),PChar(ext));
               if(fn)
               { 
      HICON exe = ExtractIconEx(PChar(rr),0,NULL,&hIconSmall,1);
           if(exe==0)
         DrawIconEx(Control->dc,5,indx,_prop_IconExe,24,24,0,NULL,DI_NORMAL);
        else DrawIconEx(Control->dc,5,indx,hIconSmall,20,20,0,NULL,DI_NORMAL);
        DestroyIcon(exe);
           cf++;
           indx+=22;
                } 
              else           
              { ext = L".ini";
                fn = wcsstr(PChar(rs),PChar(ext));
                if(fn)
           { DrawIconEx(Control->dc,5,indx,_prop_IconIni,24,24,0,NULL,DI_NORMAL);
             cf++;
             indx+=22; }
               else
                 { ext = L".txt";
                   fn = wcsstr(PChar(rs),PChar(ext));
                     if(fn)
           { DrawIconEx(Control->dc,5,indx,_prop_IconTxt,24,24,0,NULL,DI_NORMAL);
                 cf++;
                 indx+=22; }
                     else
                        { ext = L".dll";
                          fn = wcsstr(PChar(rs),PChar(ext));
                            if(fn)
           { DrawIconEx(Control->dc,5,indx,_prop_IconDll,24,24,0,NULL,DI_NORMAL);
                   cf++;
                   indx+=22; }
                         else
                          { ext = L".lnk";
                           string scut; 
                         fn = wcsstr(PChar(rs),PChar(ext)); 
                            if(fn)              
                 { //SHGetShortcutTarget(PChar(rr),PChar(scut),86);            
               HICON lnk = ExtractIconEx(PChar(scut),0,NULL,&hIconSmall,1);
                               if(lnk==0) 
           DrawIconEx(Control->dc,5,indx,_prop_IconLnk,24,24,0,NULL,DI_NORMAL);
        else DrawIconEx(Control->dc,5,indx,hIconSmall,24,24,0,NULL,DI_NORMAL);                                
                                  } 
            else  DrawIconEx(Control->dc,5,indx,_prop_IconAny,24,24,0,NULL,DI_NORMAL); 
                   cf++;
                   indx+=22;                                       
                            }
                          }
                        }
                      }             
              }     
         EndPaint(bn, &ps);
         DeleteDC(dc);
         delete buf; 
         DestroyIcon(hIconSmall);
         if(d==0)
           { 
           TData qt;
           _work_doAdd(qt,0);          
          }         
}

 void THIContentsDirectory::Start()
    {   
        HI_RSTRING buf[128];
         sel = SendMessage(Control->Handle,LB_GETCURSEL,0,0); //  
         if(sel>0)
         {                                   
         SendMessage(Control->Handle,LB_GETTEXT,sel,(long)buf);
               slc=buf;
              slc.Delete(1,5); 
              if(sel>cd); //  
              { int lng= name.Length();
               string out=name;
               out.Delete(lng-2,3);
              _hi_onEvent(_event_onChange,out+slc);}
              if(sel<=cd)//  
              { FList->Clear();
               d=0; }
               TData qt;
              _work_doOpen(qt,0);  
          }                                  
          else  { TData qt;       
              _work_doOpen(qt,0);} 
              
              if(sel==0)
               {TData qt;
              _work_doAdd(qt,0);}
               
   }

   void THIContentsDirectory::Scroll() { TData qt; _work_doOpen(qt,0);}
   
      
   void THIContentsDirectory::_work_doVScroll(TData &_Data,WORD Index)
{
    int Ind = ToIntIndex(_Data);
  SendMessage(Control->Handle,LB_SETTOPINDEX,Ind,0);
               TData qt;
              _work_doOpen(qt,0);
}
#endif